<?php

/*
 * OUGC Awards plugin
 * Author: Omar Gonzalez.
 * Copyright: © 2012 Omar Gonzalez, All Rights Reserved
 * 
 * Website: http://www.udezain.com.ar
 *
 * This plugin will extend your forum with a powerful Awards System.
 *
************************************************************/

/*
 * This plugin is under uDezain free plugins license. In short:
 * ============================================================
 * 1.- You may edit whatever you want to fit your needs without premission.
 * 2.- You MUST NOT redistribute this or any modified version of this plugin by any means without the author written permission.
 * 3.- You MUST NOT remove any license comments in any file that comes with this plugin pack.
 *
 * By downloading / installing / using this plugin you accept these conditions and the full attached license.
 * If no license file was attached within this plugin pack, you can read it in the following places:
 * 	1.- http://www.udezain.com.ar/eula-free.txt
 * 	2.- http://www.udezain.com.ar/eula-free.php
************************************************************/

// Boring stuff..
define("IN_MYBB", 1);
require_once "./global.php";

// Only administratos can run this file.
if($mybb->usergroup['cancp'] != 1)
{
	error_no_permission();
}

// We need out plugin file.
require_once MYBB_ROOT.'inc/plugins/ougc_awards/plugin.php';


global $lang, $db;
ougc_awards_lang_load();

// Modify our users column.
$db->modify_column('ougc_awards', 'users', "text NOT NULL DEFAULT ''");

// Inser our new settings
$set1 = $db->fetch_field($db->simple_select('settings', 'sid', 'name="ougc_awards_multipage"'), 'sid');
$set2 = $db->fetch_field($db->simple_select('settings', 'sid', 'name="ougc_awards_pmuser" AND disporder!="8"'), 'sid');
$set3 = $db->fetch_field($db->simple_select('settings', 'sid', 'name="ougc_awards_pmuserid"'), 'sid');
$setgroup = $db->fetch_field($db->simple_select('settinggroups', 'gid', 'name="ougc_awards"'), 'gid');

if(!$set1 && $setgroup)
{
	$db->insert_query('settings',
		array(
			'name'			=>	$db->escape_string('ougc_awards_multipage'),
			'title'			=>	$db->escape_string("Enable Multipage"),
			'description'	=>	$db->escape_string("Choose whether to show or no to use a multipage for profiles."),
			'optionscode'	=>	'yesno',
			'value'			=>	0,
			'disporder'		=>	7,
			'gid'			=>	intval($setgroup)
		)
	);
}

if(!$set3 && $setgroup)
{
	$db->insert_query('settings',
		array(
			'name'			=>	$db->escape_string('ougc_awards_pmuserid'),
			'title'			=>	$db->escape_string("PM UserID"),
			'description'	=>	$db->escape_string("Choose the PM author. -1 = MyBB Engine. (Only works if above is set to [NO])"),
			'optionscode'	=>	'text',
			'value'			=>	-1,
			'disporder'		=>	9,
			'gid'			=>	intval($setgroup)
		)
	);
}

if($set2)
{
	$db->update_query('settings', array('disporder' => '8'), "sid='{$set2}'");
}
rebuild_settings();

// Modify some templates.
require_once MYBB_ROOT.'/inc/adminfunctions_templates.php';
find_replace_templatesets('ougc_awards_page_view_row', '#'.preg_quote('{$user[\'username\']}').'#', '{$gived[\'username\']}', 0);
find_replace_templatesets('member_profile_ougc_awards', '#'.preg_quote('</table>').'#', '{$multipage}', 0);

// Delete one template.
$db->delete_query('templates', "title IN('ougc_awards_image') AND sid='-2'");

// Now we need to refresh the cache.
ougc_awards_update_cache();

echo "Done";
?>